	
class RemapButtons extends _UCR.Classes.Plugin {
	Type := "Remapper (Remap Buttons)"
	Description := "Remaps 20 joystick buttons"	
	NumberOfButtons := 20

	Init(){  ; Create the GUI
				
		;Each group of buttons requires its own loop because they position relative to each other.	
		Loop % this.NumberOfButtons {  ; Create Input Buttons
			if(A_Index==1) {
				Gui, Add, GroupBox, Center x175 ym w165 h760	section, Input Button        .
				this.AddControl("InputButton", "IB" + A_Index+1, 0, this.MyHkChangedState.Bind(this), "xs+5 yp+15")
				this.AddControl("ButtonPreview", "", 0, this.IOControls["IB" A_Index+1], "x+5 yp+5")			
			}else{
				this.AddControl("InputButton", "IB" + A_Index+1, 0, this.MyHkChangedState.Bind(this), "xs+5 yp+32")
				this.AddControl("ButtonPreview", "", 0, this.IOControls["IB" A_Index+1], "x+5 yp+5")
			}	
		}

		Loop % this.NumberOfButtons {   ; Create Output Buttons
			if(A_Index==1) {
				Gui, Add, GroupBox, Center x340 ym w170 h760 section, Output Button            .
				this.AddControl("OutputButton", "OB" + A_Index, 0, "xs+5 yp+15")
				this.AddControl("ButtonPreview", "", 0, this.IOControls["OB" A_Index], "x+5 yp+5")
			}else{
				this.AddControl("OutputButton", "OB" + A_Index, 0, "xs+5 yp+32")
				this.AddControl("ButtonPreview", "", 0, this.IOControls["OB" A_Index], "x+5 yp+5")
			}
		}
						
		;Clear the controls , otherwise they sometimes initialize with a '-1'	
		loop % this.NumberOfButtons + 1 {
		this.IOControls["IB" A_Index].Set(0)
		}
	
	}
	
	; The main code is here. Called when a button changes state (pressed or released)
	MyHkChangedState(e){
		;OutputDebug, % "UCR| Plugin" this.Name " changed state to: " (e ? "Down" : "Up")		
		
						Loop % this.NumberOfButtons 
						this.IOControls["OB" A_Index].Set(this.IOControls["IB" A_Index+1].Get())
	}

}
